/* eslint no-use-before-define:0, no-console:0, class-methods-use-this:0 */
'use strict';

// Import
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct.bind(); } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get.bind(); } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }
function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var EventEmitterGrouped = require('event-emitter-grouped');
var _require = require('taskgroup'),
  Task = _require.Task,
  TaskGroup = _require.TaskGroup;

/**
 * Error Log.
 * @typedef {Object} ErrorLog
 * @property {Error} error
 * @property {Suite} [suite]
 * @property {Test} [test]
 * @property {string} [name] used for things like uncaught exceptions, where suite and test are both null
 */

/**
 * Error Logs.
 * @typedef {Array<ErrorLog>} ErrorLogs
 */

/**
 * Reporter.
 * @typedef {Object} Reporter
 */

/**
 * @typedef Totals
 * @property {number} totalSuites
 * @property {number} totalPassedSuites
 * @property {number} totalFailedSuites
 * @property {number} totalIncompleteSuites
 * @property {number} totalTests
 * @property {number} totalPassedTests
 * @property {number} totalFailedTests
 * @property {number} totalIncompleteTests
 * @property {number} totalErrors
 * @property {boolean} success
 *
 */

// =================================
// Generic

/**
 * Set Configuration
 * Used by {@link Test.setConfig} and {@link Suite.setConfig} to add support for before and after.
 * @listens before
 * @listens after
 * @returns {Suite|Test} the context of the caller
 * @private
 */
function _setConfig() {
  var _this$config = this.config,
    before = _this$config.before,
    after = _this$config.after;
  if (before) {
    delete this.config.before;
    this.on('before', before);
  }
  if (after) {
    delete this.config.after;
    this.on('after', after);
  }
  return this;
}

/**
 * Run
 * Used by {@link Test.run} and {@link Suite.run} to emit before, and error if it failed.
 * @emits before
 * @emits error
 * @param {function} next
 * @param  {...any} args
 * @returns {Suite|Test} the context of the caller
 * @private
 */
function _run(next) {
  var _this = this;
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  if (!this.started) {
    this.emitSerial('before', function (err) {
      if (err) _this.emit('error', err);
      next.apply(_this, args);
    });
  } else {
    next.apply(this, args);
  }
  return this;
}

/**
 * Finish
 * Used by {@link Test.finish} and {@link Suite.finish} to emit after, and error if it failed.
 * @emits after
 * @emits error
 * @param {function} next
 * @param  {...any} args
 * @returns {Suite|Test} the context of the caller
 * @private
 */
function _finish(next) {
  var _this2 = this;
  for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    args[_key2 - 1] = arguments[_key2];
  }
  if (!this.exited) {
    this.emitSerial('after', function (err) {
      if (err) _this2.emit('error', err);
      next.apply(_this2, args);
    });
  } else {
    next.apply(this, args);
  }
  return this;
}

// =================================
// Test

/**
 * Test
 * The Test class extends the {@link TaskGroup.Task} class.
 */
var Test = /*#__PURE__*/function (_Task) {
  _inherits(Test, _Task);
  var _super = _createSuper(Test);
  function Test() {
    _classCallCheck(this, Test);
    return _super.apply(this, arguments);
  }
  _createClass(Test, [{
    key: "setConfig",
    value:
    /**
     * Set Configuration
     * Fires {@link Task.setConfig}, then fires {@link setConfig}.
     * @param {...any} args
     * @returns {this}
     */
    function setConfig() {
      var _get2;
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }
      (_get2 = _get(_getPrototypeOf(Test.prototype), "setConfig", this)).call.apply(_get2, [this].concat(args));
      return _setConfig.call(this);
    }

    /**
     * Run
     * Fires {@link Task.run} , then fires {@link run}.
     * @param {...any} args
     * @returns {this}
     */
  }, {
    key: "run",
    value: function run() {
      for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }
      return _run.call(this, _get(_getPrototypeOf(Test.prototype), "run", this), args);
    }

    /**
     * Finish
     * Fires {@link Task.finish}, then fires {@link finish}.
     * @param {...any} args
     * @returns {this}
     */
  }, {
    key: "finish",
    value: function finish() {
      for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        args[_key5] = arguments[_key5];
      }
      return _finish.call(this, _get(_getPrototypeOf(Test.prototype), "finish", this), args);
    }
  }], [{
    key: "create",
    value:
    /**
     * Create a new instance of the Test class with the provided arguments.
     * @param  {...any} args
     * @returns {Test}
     */
    function create() {
      for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
        args[_key6] = arguments[_key6];
      }
      return _construct(this, args);
    }

    /**
     * Check if the input is an instance of the Test class.
     * @param {*} value
     * @returns {boolean}
     */
  }, {
    key: "isTest",
    value: function isTest(value) {
      return value instanceof Test;
    }
  }]);
  return Test;
}(Task); // =================================
// Suite
/**
 * Suite
 * The Suite class extends the {@link TaskGroup.TaskGroup} class.
 */
var Suite = /*#__PURE__*/function (_TaskGroup) {
  _inherits(Suite, _TaskGroup);
  var _super2 = _createSuper(Suite);
  /**
   * Suite Constructor.
   * Listens to our added events on the TaskGroup, storing the results, for use for our reporters.
   * @emits test.before
   * @emits test.after
   * @emits suite.before
   * @emits suite.after
   * @constructor
   * @param  {...any} args
   */
  function Suite() {
    var _this3;
    _classCallCheck(this, Suite);
    for (var _len7 = arguments.length, args = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
      args[_key7] = arguments[_key7];
    }
    _this3 = _super2.call.apply(_super2, [this].concat(args));
    var me = _assertThisInitialized(_this3);

    // Shallow Listeners
    _this3.on('item.add', function (item) {
      if (Test.isTest(item)) {
        item.on('running', function () {
          me.testRunCallback(item);
        });
        item.done(function (err) {
          me.testCompleteCallback(item, err);
        });
        item.on('before', function (complete) {
          me.emitSerial('test.before', this, complete);
        });
        item.on('after', function (complete) {
          me.emitSerial('test.after', this, complete);
        });
      } else if (Suite.isSuite(item)) {
        item.on('running', function () {
          me.suiteRunCallback(item);
        });
        item.done(function (err) {
          me.suiteCompleteCallback(item, err);
        });
        item.on('before', function (complete) {
          me.emitSerial('suite.before', this, complete);
        });
        item.on('after', function (complete) {
          me.emitSerial('suite.after', this, complete);
        });
      }

      // Add nested listener
      // nestedListener(item)
    });

    // Chain
    return _possibleConstructorReturn(_this3, _assertThisInitialized(_this3));
  }

  /**
   * Add Method.
   * Wrapped around {@link TaskGroup.addMethod} that sets the defaults the taskgroup initializer.
   * Defaults config.reporting to false, to prevent the initialiser for suites being included in the reporting results.
   * Defaults config.name to mention that it is a suite initalizer.
   * Defaults the args to start with {@link Suite.suite} and {@link Suite.test}.
   * @param {*} method
   * @param {*} config
   * @returns {any} whatever {@link TaskGroup.addMethod} returns
   */
  _createClass(Suite, [{
    key: "setConfig",
    value:
    /**
     * Set Configuration
     * Fires {@link TaskGroup.setConfig}, then fires {@link setConfig}.
     * @param {...any} args
     * @returns {this}
     */
    function setConfig() {
      var _get3;
      for (var _len8 = arguments.length, args = new Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
        args[_key8] = arguments[_key8];
      }
      (_get3 = _get(_getPrototypeOf(Suite.prototype), "setConfig", this)).call.apply(_get3, [this].concat(args));
      return _setConfig.call(this);
    }

    /**
     * Run
     * Fires {@link TaskGroup.run}, then fires {@link run}.
     * @param {...any} args
     * @returns {this}
     */
  }, {
    key: "run",
    value: function run() {
      for (var _len9 = arguments.length, args = new Array(_len9), _key9 = 0; _key9 < _len9; _key9++) {
        args[_key9] = arguments[_key9];
      }
      return _run.call.apply(_run, [this, _get(_getPrototypeOf(Suite.prototype), "run", this)].concat(args));
    }

    /**
     * Finish
     * Fires {@link TaskGroup.finish}, then fires {@link finish}.
     * @param {...any} args
     * @returns {this}
     */
  }, {
    key: "finish",
    value: function finish() {
      for (var _len10 = arguments.length, args = new Array(_len10), _key10 = 0; _key10 < _len10; _key10++) {
        args[_key10] = arguments[_key10];
      }
      return _finish.call.apply(_finish, [this, _get(_getPrototypeOf(Suite.prototype), "finish", this)].concat(args));
    }

    /**
     * Wrapper around {@link TaskGroup.addTaskGroup} for creating a nested suite.
     * @param  {...any} args
     * @returns {Suite}
     */
  }, {
    key: "suite",
    value: function suite() {
      for (var _len11 = arguments.length, args = new Array(_len11), _key11 = 0; _key11 < _len11; _key11++) {
        args[_key11] = arguments[_key11];
      }
      var suite = _construct(Suite, args);
      return this.addTaskGroup(suite);
    }

    /**
     * Alias for {@link Suite.suite}.
     * @param  {...any} args
     * @returns {Suite}
     */
  }, {
    key: "describe",
    value: function describe() {
      return this.suite.apply(this, arguments);
    }

    /**
     * Wrapper around {@link TaskGroup.addTask} for creating a nested test.
     * @param  {...any} args
     * @returns {Suite}
     */
  }, {
    key: "test",
    value: function test() {
      for (var _len12 = arguments.length, args = new Array(_len12), _key12 = 0; _key12 < _len12; _key12++) {
        args[_key12] = arguments[_key12];
      }
      var test = _construct(Test, args);
      return this.addTask(test);
    }

    /**
     * Alias for {@link Suite.it}.
     * @param  {...any} args
     * @returns {Test}
     */
  }, {
    key: "it",
    value: function it() {
      return this.test.apply(this, arguments);
    }
  }, {
    key: "addMethod",
    value: function addMethod(method) {
      var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      if (config.reporting == null) config.reporting = false;
      if (config.name == null) config.name = `suite initializer for ${this.name}`;
      if (config.args == null) config.args = [this.suite.bind(this), this.test.bind(this)];
      if (method.length === 0) {
        var error = new Error(`An invalid amount of arguments were specified for the Suite: ${config.name}\n` + 'Did you intend to create a test instead?\n' + method.toString());
        console.error(error);
        throw error;
      }
      return _get(_getPrototypeOf(Suite.prototype), "addMethod", this).call(this, method, config);
    }

    // =================================
    // Callbacks

    /**
     * Suite Run Callback.
     * Handles {@link Private.totalSuites}.
     * Fires the startSuite report.
     * @param {Suite} suite
     * @returns {void}
     */
  }, {
    key: "suiteRunCallback",
    value: function suiteRunCallback(suite) {
      var report = suite.config.reporting !== false;
      if (report) {
        ++Private.totalSuites;
        Public.report('startSuite', suite);
      }
    }

    /**
     * Suite Complete Callback.
     * Handles {@link Private.totalFailedSuites}, {@link Private.totalPassedSuites}.
     * Fires the startSuite report.
     * @param {Suite} suite
     * @param {Error?} error
     * @returns {void}
     */
  }, {
    key: "suiteCompleteCallback",
    value: function suiteCompleteCallback(suite, error) {
      var report = suite.config.reporting !== false;
      if (error) {
        Private.addErrorLog({
          error,
          suite
        });
        if (report) {
          ++Private.totalFailedSuites;
        }
      } else if (report) {
        ++Private.totalPassedSuites;
      }
      if (error || report) {
        Public.report('finishSuite', suite, error);
      }
    }

    /**
     * Test Run Callback.
     * Handles {@link Private.totalTests}.
     * Fires the startTest report.
     * @param {Test} test
     * @returns {void}
     */
  }, {
    key: "testRunCallback",
    value: function testRunCallback(test) {
      var report = test.config.reporting !== false;
      if (report) {
        ++Private.totalTests;
        Public.report('startTest', test);
      }
    }

    /**
     * Test Complete Callback.
     * Handles {@link Private.totalFailedTests}, {@link Private.totalPassedTests}.
     * Fires the finishTest report.
     * @param {Test} test
     * @param {Error?} error
     * @returns {void}
     */
  }, {
    key: "testCompleteCallback",
    value: function testCompleteCallback(test, error) {
      var report = test.config.reporting !== false;
      if (error) {
        Private.addErrorLog({
          error,
          test
        });
        if (report) {
          ++Private.totalFailedTests;
        }
      } else if (report) {
        ++Private.totalPassedTests;
      }
      if (error || report) {
        Public.report('finishTest', test, error);
      }
    }
  }], [{
    key: "create",
    value:
    /**
     * Create a new instance of the Suite class with the provided arguments.
     * @param  {...any} args
     * @returns {Suite}
     */
    function create() {
      for (var _len13 = arguments.length, args = new Array(_len13), _key13 = 0; _key13 < _len13; _key13++) {
        args[_key13] = arguments[_key13];
      }
      return _construct(this, args);
    }

    /**
     * Check if the input is an instance of the Suite class.
     * @param {*} value
     * @returns {boolean}
     */
  }, {
    key: "isSuite",
    value: function isSuite(value) {
      return value instanceof Suite;
    }
  }]);
  return Suite;
}(TaskGroup); // =================================
// Event Emitter Grouped
// Add event emitter grouped to our classes
Object.getOwnPropertyNames(EventEmitterGrouped.prototype).forEach(function (key) {
  Test.prototype[key] = Suite.prototype[key] = EventEmitterGrouped.prototype[key];
});

// =================================
// Private Interface

/**
 * Kava's Private Interface.
 * The reason we have a public and private interface is that we do not want tests being able to modify the test results.
 * As such, the private interface contains properties that must be mutable by the public interface, but not mutable by the bad tests.
 * @private
 * @namespace
 */
var Private = {
  /**
   * Global Suite.
   * We use a global suite to contain all of the Suite suites and tests.
   * @type {Suite?}
   */
  globalSuite: null,
  /**
   * Get Global Suite.
   * We have a getter for the global suite to create it when it is actually needed.
   * @returns {Suite}
   */
  getGlobalSuite() {
    // If it doesn't exist, then create it and name it kava
    if (Private.globalSuite == null) {
      Private.globalSuite = new Suite({
        reporting: false,
        name: 'global kava suite'
      }).run();
    }

    // Return the global suite
    return Private.globalSuite;
  },
  /**
   * Error Logs.
   * We log all the errors that have occurred with their suite and test, so the reporters can access them.
   * @type {ErrorLogs}
   */
  errorLogs: [],
  /**
   * Add Error Log.
   * Logs an error into the errors array, however only if we haven't already logged it.
   * @param {ErrorLog} errorLog
   * @returns {Private}
   */
  addErrorLog(errorLog) {
    var lastLog = this.errorLogs[this.errorLogs.length - 1];
    if (errorLog.error === (lastLog && lastLog.error)) {
      // ignore
    } else {
      this.errorLogs.push(errorLog);
    }
    return this;
  },
  /**
   * Exited?
   * Whether or not we have already exited, either via error or via finishing everything it is meant to be doing.
   * We store this flag, as we do not want to exit multiple times if we have multiple errors or exit signals.
   * @type {Boolean}
   */
  exited: false,
  /**
   * Reporters.
   * This is a listing of all the reporters we will be using.
   * Reporters are what output the results of our tests/suites to the user (we just run them).
   * @type {Array<Reporter>}
   */
  reporters: [],
  /**
   * Total Suites.
   * The total amount of suites that we are currently aware of.
   * @type {number}
   */
  totalSuites: 0,
  /**
   * Total Passed Suites.
   * The total amount of passed suites that we are currently aware of.
   * @type {number}
   */
  totalPassedSuites: 0,
  /**
   * Total Failed Suites.
   * The total amount of failed suites that we are currently aware of.
   * @type {number}
   */
  totalFailedSuites: 0,
  /**
   * Total Tests.
   * The total amount of tests that we are currently aware of.
   * @type {number}
   */
  totalTests: 0,
  /**
   * Total Passed Tests.
   * The total amount of passed tests that we are currently aware of.
   * @type {number}
   */
  totalPassedTests: 0,
  /**
   * Total Failed Tests.
   * The total amount of failed tests that we are currently aware of.
   * @type {number}
   */
  totalFailedTests: 0,
  /**
   * Get Reporters.
   * If no reporters have been set, attempt to load reporters.
   * Reporters will be loaded in order of descending preference.
   * If none are defined, the `KAVA_REPORTER` environment variable is relied upon, and if that doesn't exist, then it will default to console.
   * @returns {Array<Reporter>}
   */
  getReporters() {
    // Check if have no reporters
    if (Private.reporters.length === 0) {
      // Prepare
      var reporters = [];

      // If there are no reporters, then make use of the KAVA_REPORTER environment variable
      if (process && process.env && process.env.KAVA_REPORTER) {
        reporters.push(process.env.KAVA_REPORTER);
      }
      // Otherwise make use of console
      else {
        reporters.push('console');
      }

      // Attempt to load each reporter
      for (var index = 0; index < reporters.length; index++) {
        var value = reporters[index];
        Public.addReporter(value);
      }
    }

    // Return our reporters
    return Private.reporters;
  }
};

// =================================
// Public Interface

/**
 * Kava's Public Interface.
 * Creates the publicly accessible interface for Kava, which is exposed via `require('kava')`.
 * @namespace
 */
var Public = {
  /**
   * Get Totals.
   * Fetches all the different types of totals we have collected
   * and determines the incomplete suites and tasks
   * as well as whether or not everything has succeeded correctly (no incomplete, no failures, no errors)
   * @returns {Totals}
   */
  getTotals() {
    // Fetch
    var totalSuites = Private.totalSuites,
      totalPassedSuites = Private.totalPassedSuites,
      totalFailedSuites = Private.totalFailedSuites,
      totalTests = Private.totalTests,
      totalPassedTests = Private.totalPassedTests,
      totalFailedTests = Private.totalFailedTests,
      errorLogs = Private.errorLogs;

    // Calculate
    var totalIncompleteSuites = totalSuites - totalPassedSuites - totalFailedSuites;
    var totalIncompleteTests = totalTests - totalPassedTests - totalFailedTests;
    var totalErrors = errorLogs.length;
    var success = totalIncompleteSuites === 0 && totalFailedSuites === 0 && totalIncompleteTests === 0 && totalFailedTests === 0 && totalErrors === 0;

    // Return
    var result = {
      totalSuites,
      totalPassedSuites,
      totalFailedSuites,
      totalIncompleteSuites,
      totalTests,
      totalPassedTests,
      totalFailedTests,
      totalIncompleteTests,
      totalErrors,
      success
    };
    return result;
  },
  /**
   * Get Errors.
   * Returns a cloned array of all the error logs.
   * @returns {ErrorLogs}
   */
  getErrorLogs() {
    return Private.errorLogs.slice();
  },
  /**
   * Has Errors.
   * Returns false if there were no incomplete, no failures and no errors.
   * @returns {boolean}
   */
  hasErrors() {
    return this.getTotals().success === false;
  },
  /**
   * Has Exited.
   * Returns true if we have exited already, as we do not want to exit multiple times.
   * @returns {boolean}
   */
  hasExited() {
    return Private.exited === true;
  },
  /**
   * Has Reporters.
   * Do we have any reporters yet?
   * @returns {boolean}
   */
  hasReporters() {
    return Array.isArray(Private.reporters) && Private.reporters.length !== 0;
  },
  /**
   * Add Reporter.
   * Add a reporter to the list of reporters we will be using.
   * @param {string} reporter The name or path of the reporter to use.
   * @param {Object} [config] Any custom configuration that you want to configure the reporter with.
   * @returns {Reporter}
   */
  addReporter(reporter) {
    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    // Match
    var path;
    switch (reporter) {
      case 'console':
      case 'kava-reporter-console':
        path = './reporters/console/index.js';
        break;
      case 'list':
      case 'kava-reporter-list':
        path = './reporters/console/list.js';
        break;
      default:
        path = reporter;
    }

    // Load
    var Klass = require(path);

    // Instantiate
    var instance = new Klass(_objectSpread({
      kava: this
    }, config));

    // Add the reporter to the list of reporters we have
    Private.reporters.push(instance);

    // Chain
    return instance;
  },
  /**
   * Set Reporter.
   * Clear all the other reporters we may be using, and just use this one.
   * @param {string} reporter The name or path of the reporter to use.
   * @param {Object} [config] Any custom configuration that you want to configure the reporter with.
   * @returns {Reporter}
   */
  setReporter(reporter, config) {
    Private.reporters = [];
    return this.addReporter(reporter, config);
  },
  /**
   * Report.
   * Report an event to our reporters.
   * @param {string} event
   * @param {...any} args
   * @returns {Public}
   */
  report(event) {
    // Fetch the reporters
    var reporters = Private.getReporters();

    // Check we have reporters
    for (var _len14 = arguments.length, args = new Array(_len14 > 1 ? _len14 - 1 : 0), _key14 = 1; _key14 < _len14; _key14++) {
      args[_key14 - 1] = arguments[_key14];
    }
    if (reporters.length === 0) {
      var _console;
      (_console = console).error.apply(_console, ['kava has no reporters to log:', event].concat(args));
      this.exit(1);
      return this;
    }

    // For each reporter that we have
    // Trigger the event handler if it exists for it
    for (var i = 0; i < reporters.length; ++i) {
      var reporter = reporters[i];
      if (reporter[event]) reporter[event].apply(reporter, args);
    }

    // Chain
    return this;
  },
  /**
   * Exit.
   * Exit our process with the specifeid exitCode.
   * If no exitCode is set, then we determine it through the hasErrors call.
   * @param {number} [exitCode=0]
   * @param {string} [reason]
   * @returns {Public}
   */
  exit() {
    var exitCode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var reason = arguments.length > 1 ? arguments[1] : undefined;
    // Check
    if (this.hasExited()) return;
    Private.exited = true;

    // Determine exit code
    if (!exitCode) {
      exitCode = this.hasErrors() ? 1 : 0;
    }

    // Stop running more tests if we have begun
    var suite = Private.getGlobalSuite();
    if (suite) suite.destroy();

    // Report our exit
    this.report('exit', exitCode, reason);

    // Kill our process with the correct exit code
    if (process && process.exit) {
      process.exit(exitCode);
    }

    // Chain
    return this;
  },
  /**
   * Creates a nested suite on the global suite instance.
   * @param {...any} args
   * @returns {any} Whatever {@link Suite.suite} returns.
   */
  suite() {
    var _Private$getGlobalSui;
    return (_Private$getGlobalSui = Private.getGlobalSuite()).suite.apply(_Private$getGlobalSui, arguments);
  },
  /**
   * Alias for {@link Public.suite}.
   * @param {...any} args
   * @returns {any} Whatever {@link Suite.suite} returns.
   */
  describe() {
    return this.suite.apply(this, arguments);
  },
  /**
   * Creates a nested test on the global suite instance.
   * @param {...any} args
   * @returns {any} Whatever {@link Suite.test} returns.
   */
  test() {
    var _Private$getGlobalSui2;
    return (_Private$getGlobalSui2 = Private.getGlobalSuite()).test.apply(_Private$getGlobalSui2, arguments);
  },
  /**
   * Alias for {@link Public.test}.
   * @param {...any} args
   * @returns {any} Whatever {@link Suite.test} returns.
   */
  it() {
    return this.test.apply(this, arguments);
  }
};

// Freeze our public interface from changes
if (Object.freeze) {
  Object.freeze(Public);
}

// =================================
// Events

// On node systems, wait until the process exits
// such that errors that occur outside of the tests can be caught before we shut down
if (process) {
  process.on('beforeExit', function () {
    Public.exit(0, 'beforeExit');
  });
  process.on('exit', function () {
    Public.exit(0, 'exit');
  });

  // Have last, as this way it won't silence errors that may have occurred earlier
  process.on('uncaughtException', function (error) {
    if (!error) error = new Error('uncaughtException was emitted without an error');
    Private.addErrorLog({
      error,
      name: 'uncaughtException'
    });
    Public.exit(1, 'uncaughtException');
  });
}

// On browser systems, wait until the tests have finished
else {
  Private.getGlobalSuite().on('destroyed', function () {
    Public.exit(0, 'destroyed');
  });
}

// =================================
// Export

module.exports = Public;